$(document).ready(function(){
  
  if ($('body').hasClass('loginPage')) {
    
    $('.loginLink').click(function(){
      var form = $(this).attr('rel');
      $('form').hide();
      $('.'+form).css('display','block');
      
      return false;
    })
  
    if (window.localStorage.getItem("myUserID") !== null) {
      window.location = "app.html";
    }
    
    $(document).on('click','.submitLogin',function(){
      var username = $('.loginUsername').val();
      var pass = $('.loginPass').val();
      
      if (username == '' || pass == '') {
        showAlert("Please fill in both fields.",2500);
      } else {
        $.ajax({
          dataType: "JSON",
          url: "http://sportscardalbum.com/api/login",
          data: {user:username,pass:pass},
          type: "POST",
          success: function(data){
            if (data.response[0].code == 2) {
              showAlert(data.response[0].responseText, 2500);
            } else {
              window.localStorage.setItem("myUserID",data.response[0].id);
              window.localStorage.setItem("myUserKey",data.response[0].key);
              window.localStorage.setItem("myImg",data.response[0].profileImg);
              window.localStorage.setItem("myUsername",data.response[0].username);
              window.location = "app.html";
            }
          }
        })
      }
      
      return false;
    })
    .on('click','.submitRegister',function(){
      var email = $('.regEmail').val();
      var username = $('.regUsername').val();
      var pass = $('.regPass').val();
      
      console.log(email+','+username+','+pass);
      
      if (email == '' || username == '' || pass == '') {
        showAlert("Please fill in all fields.",2500);
      } else {
        $.ajax({
          dataType: "JSON",
          url: "http://sportscardalbum.com/api/register",
          data: {email:email,username:username,pass:pass},
          type: "POST",
          success: function(data){
            if (data.response[0].code == 2) {
              showAlert(data.response[0].responseText, 2500);
            } else {
              window.localStorage.setItem("myUserID",data.response[0].id);
              window.localStorage.setItem("myUserKey",data.response[0].key);
              window.localStorage.setItem("myImg",data.response[0].profileImg);
              window.localStorage.setItem("myUsername",data.response[0].username);
              window.location = "app.html";
            }
          }
        })
      }
      
      return false;
    })
    .on('click','.submitForgot',function(){
      var email = $('.forgotUsername').val();
      
      if (email == '') {
        showAlert("Please fill in all fields.",2500);
      } else {
        $.ajax({
          dataType: "JSON",
          url: "http://sportscardalbum.com/api/passwordreset",
          data: {email:email},
          type: "POST",
          success: function(data){
            showAlert(data.response[0].responseText, 2500);
            $('.forgot').hide();
            $('.login').show();
          }
        })
      }
      
      return false;
    })
    
  } else {
    
    $(document).on('click','.logout',function(){
      localStorage.clear();
      window.location = "index.html";
    })
    
    var myUserKey = window.localStorage.getItem("myUserKey");
    var myUserID = window.localStorage.getItem("myUserID");
    var myImg = window.localStorage.getItem("myImg");
    var myUsername = window.localStorage.getItem("myUsername");
    
    $(document).ready(function(){
      $('.myProfile').attr('searchUserID',myUserID);
    })
    
    
    var count = 0;
    var type = 1;
    var sport;
    var searchUserID;
    var albumID;
    var searchTerms;
    var isLoading = false;
    
    
    // Naviagtion
      $(document)
        .on('click','.nav',function(){
          $('.drawer').toggleClass('open');
          return false;
        })
        .on('click','.logo, .username',function(){
          window.scrollTo(0,0);
          return false;
        })
        .on('click','.back',function(){
          type = 1;
          sport = undefined;
          searchUserID = $(this).attr('rel');
          if (searchUserID != undefined) {
            albumID = 1;
            type = 2;
          } else {
            albumID = undefined;
          }
          loadMore = true;
          $('#hello').removeClass('nope');
          hideModal();
          loadCards(myUserID, myUserKey, 0, type, searchTerms, sport, searchUserID, albumID, true);
          
          return false;
        });
      
      
    function hideDrawer(){
      if ($('.drawer').hasClass('open')) {
        $('.drawer').removeClass('open');
      }
    }
    
    function showAlert(txt,time){
      time = time || false;
      
      $('.alert').html(txt).css('display','block');
      
      if (time) {
        setTimeout(function(){
          $('.alert').css('display','none');
        }, time);
      }
    }
    
    function hideAlert(){
      $('.alert').css('display','none').html('');
    }
    
    var myScroll;
    var loadMore = true;
    
    function loadProfile(userID,loggedUserID){
      
      if (userID == loggedUserID) {
        $('.followUser, .message').hide();
      } else {
        $('.followUser, .message').show();
      }
      
      $('.back').removeAttr('rel');
      
      $.ajax({
        dataType: "JSON",
        url: "http://sportscardalbum.com/api/userdetails",
        data: {userid:userID,loggedUserID:loggedUserID},
        success: function(data){
          var v = data.response[0];
          
          if (v.code == 1) {
            var pUsername = v.username;
            var pImg = v.profileImg;
            var pCardCount = v.cardCount;
            var pLikes = v.totalLikes;
            var pFollowers = v.followers;
            var pFollowing = v.following;
            var isFollowing = v.isFollowing;
            var pAlbumCount = v.albumCount;
            $('.username').html(pUsername);
            $('.userNav').css('display','block');
            $('.regNav').hide();
            $('.userImg').html("<img src='" + pImg + "' />");
            $('.pHeader').append("<img src='" + v.blurredImg + "' class='profileBG' />");
            $('.followers').text(pFollowers);
            $('.cardsCount').text(pCardCount);
            $('.following').text(pFollowing);
            $('.profile').css('display','block');
            $('.followUser').attr('rel',v.id);
            if (isFollowing == 1) {
              $('.followUser').addClass('isFollowing');
            }
            $('.message').attr('rel',userID);
          
            $('.albums').html('');
            
            loadUserAlbums(userID,3,pAlbumCount);
            
          } else {
            showAlert("Error: " + v.responseText);
          }
        }
      })
    }
    
    $(document).on('click','.followUser',function(){
      if ($(this).hasClass('isFollowing')) {
        $(this).removeClass('isFollowing');
      } else {
        $(this).addClass('isFollowing');
      }
      
      $.ajax({
        dataType: "JSON",
        url: "http://sportscardalbum.com/api/follow",
        data: {userID:myUserID,followID:$(this).attr('rel'),key:myUserKey},
        success: function(data){
          if (data.response[0].code == 1) {
            showAlert(data.response[0].responseText, 2500);
          } else {
            showAlert(data.response[0].responseText, 2500);
            if ($(this).hasClass('isFollowing')) {
              $(this).removeClass('isFollowing');
            } else {
              $(this).addClass('isFollowing');
            }
          }
        }
      });
      return false;
    })
    
    $(document).on('click','.loadAlbums',function(){
      showAlert('Loading All Albums...');
      loadUserAlbums($(this).attr('rel'),0);
      $('.loadAlbums').hide();
      return false;
    })
    
    function loadUserAlbums(userID,limit,totalAlbums){
      $.ajax({
        dataType: "JSON",
        url: "http://sportscardalbum.com/api/useralbums",
        data: {userid:userID,limit:limit},
        success: function(data){
          var v = data.response[0];
          var code = v.code;
          
          if (code == 1) {
            
            $('.albums').html('');
            hideAlert();
            $.each(data.albums, function(k, v){
              showAlbums(userID, v.album, 0, '.myAlbums',2);
            })
            
          }
          
          if (totalAlbums > data.albums.length) {
            $('.albums').append(
                " <div class='forth'>\
                    <a href='#' class='album loadAlbums' rel='" + userID + "'>\
                      All Albums\
                      <div class='box'><img src='img/allAlbums.jpg' /></div>\
                    </a>\
                  </div>");
          }
        }
      });
    }
    
    function loadCards(myUserID, myUserKey, count, type, searchTerms, sport, searchUserID, albumID, replace) {
      
      $('.imageDetails').css('display','none');
      
      // If messages window is shown, hide it
        if ($('.sendMessage').length > 0) {
          hideModal();
        }
      
      isLoading = true;
      $('#hello').removeClass('nope');
      
      if (searchUserID != undefined) {
        $('body').attr('id','profileView');
        loadProfile(searchUserID,myUserID);
      } else {
        $('body').removeAttr('id');
        $('.profile').css('display','none');
        $('.profileBG').remove();
        $('.userImg').html('');
        $('.userNav').css('display','none');
        $('.searchGlass').show();
        $('.regNav').show();
      }
      
      hideDrawer();
      $('.header').show();
      reload = false;
      if ($('.alert').text() == '') {
        showAlert("Loading...");
      }
      
      if (replace) {
        $('#feed').html('');
      }
      
      console.log("http://sportscardalbum.com/api/feed?type="+type+"&search="+searchTerms+"&userID="+myUserID+"&start="+40*count+"&sport="+sport+"&searchUserID="+searchUserID+"&albumID="+albumID+"&key="+myUserKey);
      
      $.ajax({
        dataType: "JSON",
        url: "http://sportscardalbum.com/api/feed",
        data: {type:type,userID:myUserID,key:myUserKey,start:40 * count,search:searchTerms,sport:sport,searchUserID:searchUserID,albumID:albumID},
        success: function(data){
          
          var cardLength = data.cards.length;
          if (cardLength < 40) {
            loadMore = false;
          }
          
          if (cardLength == 0) {
            showAlert('No cards found.', 2500);
          }
          
          var i = 0;
          
          $.each(data.cards, function(k, v){
            
            var cardID = v.cardID;
            var ad = "";
            if (cardID == 'ad') {
              ad = " ad";
            }
            var tv = v.tv;
              if (tv == 0) {
                tv = "N/A";
              }
            var sv = v.sv;
              if (sv == 0) {
                sv = "N/A";
              }
            var sn = v.sn;
              if (sn == "") {
                sn = "N/A";
              }
            var cn = v.cn;
              if (!cn) {
                cn = "N/A";
              }
            
            var backIMG = "";
            if (v.imageBackURLSmall != "") {
              backIMG = "<a href='#' class='imgPreview' rel='" + cardID + "'><img src='" + v.imageBackURLMedium + "' /></a>";
            }
            
            var isLiked = "";
            if (v.isLiked == 1) {
              isLiked = "liked";
            }
            
            var editable = "";
            if (v.userID == myUserID) {
              editable = "<a href='#' class='sportIcon right edit' rel='" + cardID + "'></a>";
            }
            
            var cardSport = v.sport;
            if (cardSport != "") {
              cardSport = "<a href='#' class='loadFeed sportIcon right " + v.sport.toLowerCase() + "' type='1' sport='" + v.sport + "'></a>";
            }
            
            $('#feed').append(
                "<div class='card'>\
                  <div class='profileInfo'>\
                    <h2><a href='#' class='loadFeed' type='2' searchUserID='" + v.userID + "' albumID='1'>" + v.username + "</a></h2>\
                    <img src='" + v.profileIMG + "' class='profileImg' />\
                    " + cardSport + "\
                    " + editable + "\
                  </div>\
                  <div class='imgHolder'>\
                    " + backIMG + "\
                    <a href='" + v.imageURL + "' class='cardImg" + ad + "' rel='" + v.url + "' id='img" + cardID + "'><img src='" + v.imageURLMedium + "' rel='" + cardID + "' /></a>\
                  </div>\
                  <div class='details'>\
                    <h4 class='cardTitle' rel='" + cardID + "'>" + v.title + "</h4>\
                    \
                    Tags: " + v.tags + "<br class='clear' />\
                    <div class='forth'>TV: " + tv + "</div>\
                    <div class='forth'>SV: " + sv + "</div>\
                    <div class='forth'>SN: " + sn + "</div>\
                    <div class='forth'>CN: " + cn + "</div>\
                  </div>\
                  <div class='social'>\
                    <div class='left' rel='" + v.imageURLMedium + "'>\
                      <a href='" + v.url + "' class='icon facebook sharing' rel='" + cardID + "'></a>\
                      <a href='" + v.url + "' class='icon twitter sharing' rel='" + cardID + "'></a>\
                      <a href='" + v.url + "' class='icon everything sharing' rel='" + cardID + "'></a>\
                      <a href='" + v.ebayLink + "' class='icon ebay' />\
                    </div>\
                    <div class='right'>\
                      <a href='#' class='icon like " + isLiked + "' rel='" + cardID + "'><span class='filledStar'></span><span class='likeNumber" + cardID + "'>" + v.likeCount + "</span></a>\
                      <a href='#' class='icon comments' rel='" + cardID + "'>" + v.commentCount + "</a>\
                    </div>\
                  </div>\
                </div>"
              );
            
            i++;
            if (i == cardLength) {
              hideAlert();
              isLoading = false;
            }
          })
        }
      });
    };
    
    $(document).on('click','.like',function(){
      var likeID = $(this).attr('rel');
      var likeHolder = $('.likeNumber'+likeID);
      var likeNumber = parseInt(likeHolder.text());
      
      if ($(this).hasClass('liked')) {
        likeNumber = likeNumber - 1;
      } else {
        likeNumber = likeNumber + 1;
      }
      
      $(this).toggleClass('liked');
      
      $.ajax({
        dataType: "JSON",
        url: "http://sportscardalbum.com/api/like",
        data: {userID:myUserID,key:myUserKey,cardID:likeID},
        success: function(data){
          if (data.response[0].code == 1) {
            showAlert(data.response[0].responseText, 2500);
            likeHolder.text(likeNumber);
            console.log("Like Number: " + likeNumber);
          } else {
            showAlert(data.response[0].responseText, 2500);
            $(this).toggleClass('liked');
          }
        }
      })
      
      return false;
    })
    
    function showAlbums(userID, array, i, targetDiv, type){
      $.each(array, function (k, v){
        var albumID = v.albumID;
        if (albumID != undefined) {
          i++;
          var albumName = v.albumName;
          var tabs = "";
          for(var t=1; t<i; t++){
            tabs += "<span class='tab'></span>";
          }
          if (type == 1) {
            $(targetDiv).append( "<a href='#' class='loadFeed block' type='2' searchUserID='" + userID + "' albumID='" + albumID + "'>" + tabs + albumName + " ("+v.cardCount+")</a>");
          }
          if (type == 2) {
            if (albumName.length > 12) {
              albumName = albumName.substring(0,12) + "...";
            }
            $('.albums').append(
                " <div class='forth'>\
                    <a href='#' class='album loadFeed' type='2' searchUserID='" + userID + "' albumID='" + albumID + "'>\
                      " + albumName + "\
                      <div class='box'>\
                        <div class='cardsInAlbum'>" + v.cardCount + "</div>\
                        <img src='" + v.topCard + "' class='crop' />\
                      </div>\
                    </a>\
                  </div>");
          }
          if (type == 3) {
            $(targetDiv).append("<option value='" + albumID + "'>" + albumName + " ("+v.cardCount+")</option>");
          }
        }
        if (array.length > 1) {
          var newArray = v.album;
          if (newArray != undefined) {
            showAlbums(userID, newArray,i, targetDiv, type);
          }
        }
      })
    }
    
    function loadAlbums(userID) {
      $.ajax({
        dataType: "JSON",
        url: "http://sportscardalbum.com/api/useralbums",
        data: {userid:userID},
        success: function(data){
          $.each(data.albums, function(k, v){
            showAlbums(userID, v.album, 0, '.myAlbums',1);
          })
        }
      })
    }
    
    function showModal(title,data){
      $('.modal').html(data + "<a href='#' class='button grey hideModal'>Cancel</a>").addClass('show');
      $('.focus').focus().select();
    }
    
    function hideModal(){
      $('.modal').removeClass('show');
      setTimeout(function(){
        $('.modal').html('');
      }, 750)
    }
    
    $(document).on('click','.hideModal',function(){
      hideModal();
      return false;
    })
    
    loadAlbums(myUserID);
    
    function str_slug(str) {
      str = str.replace(/^\s+|\s+$/g, ''); // trim
      str = str.toLowerCase();
    
      // remove accents, swap  for n, etc
      var from = "/_,:;";
      var to   = "aaaaeeeeiiiioooouuuunc------";
      for (var i=0, l=from.length ; i<l ; i++) {
        str = str.replace(new RegExp(from.charAt(i), 'g'), to.charAt(i));
      }
    
      str = str.replace(/[^a-z0-9 -]/g, '') // remove invalid chars
        .replace(/\s+/g, '-') // collapse whitespace and replace by -
        .replace(/-+/g, '-'); // collapse dashes
    
      return str;
    }
          
    $(document)
      .on('keyup','.albumName',function(){
        $('.slug').val(str_slug($(this).val()));
      })
      .on('click','.addAlbum',function(){
        
        count = 0;
        type = 2;
        searchUserID = myUserID;
        albumID = 1;
        searchTerms = "";
        
        loadCards(myUserID,myUserKey,0,type,searchTerms,sport,searchUserID,albumID,true);
        
        $('body').append("<div class='hidden holder'>\
                            <select class='albumParent'>\
                              <option value='0'>Parent Album</option>\
                              \
                            </select>\
                            <input type='text' class='albumName focus' placeholder='Album Title' />\
                            <input type='text' class='slug' placeholder='Album Slug' disabled />\
                            <a href='#' class='button gold submitAlbum'>Add Album</a>\
                          </div>");
        
        $.ajax({
          dataType: "JSON",
          url: "http://sportscardalbum.com/api/useralbums",
          data: {userid:myUserID},
          success: function(data){
            var totalAlbums = data.albums.length;
            var i = 0;
            
            if (totalAlbums == 0) {
              var modalData = $('.hidden.holder').html();
              showModal("Add an Album",modalData);
            } else {
              $.each(data.albums, function(k, v){
                showAlbums(myUserID, v.album, 0, '.albumParent',3);
                i++;
                if (i == totalAlbums) {
                  var modalData = $('.hidden.holder').html();
                  showModal("Add an Album",modalData);
                }
              });
            }
          }
        });
        
        return false;
      })
      .on('click','.submitAlbum',function(){
        var parentAlbum = $('.albumParent').val();
        var albumName = $('.albumName').val();
        var slug = $('.slug').val();
        
        $.ajax({
          dataType: "JSON",
          url: "http://sportscardalbum.com/api/addalbum",
          data: {userID:myUserID,key:myUserKey,parent:parentAlbum,name:albumName,slug:slug},
          success: function(data){
            var code = data.response[0].code;
            console.log(code);
            if (code == 1) {
              showAlert('Album Added!',2500);
              $('.myAlbums').html('');
              loadAlbums(myUserID);
              hideModal();
            } else {
              showAlert(data.response[0].responseText,2500);
            }
          }
        })
        
        return false;
      })
      
      // Searching Functions
      
      $(document).on('change','.searchType',function(){
        $('.searchTerms').focus();
      })
      
      function searchResults(searchType,terms){
        reload = false;
        $('#hello').addClass('nope');
        $('#feed').html('');
        showAlert("Searching \"" + terms + "\"...");
          
        switch (searchType){
          case "1":
            count = 0;
            type = 2;
            sport = undefined;
            searchUserID = undefined;
            albumID = undefined;
            searchTerms = terms;
            loadCards(myUserID, myUserKey, 0, type, searchTerms, sport, searchUserID, albumID, true);
            $('#hello').removeClass('nope');
            
            break;
          
          case "2":
            count = 0;
            type = 2;
            searchTerms = terms;
            loadCards(myUserID, myUserKey, 0, type, searchTerms, sport, searchUserID, albumID, true);
            $('#hello').removeClass('nope');
            
            break;
          
          case "3":
            $('.header').css('display','block');
            $.ajax({
              dataType: "JSON",
              url: "http://sportscardalbum.com/api/usersearch",
              data: {userid:myUserID,search:terms},
              success: function(data){
                $.each(data.users, function(k, v){
                  var isFollowing = v.isFollowing;
                  if (isFollowing != 0) {
                    isFollowing = "isFollowing";
                  }
                  $('#feed').append("<a href='#' class='loadFeed userSearch' type='2' searchUserID='" + v.id + "' albumID='1'>\
                                      <img src='" + v.profileImg + "' class='userImg' />\
                                      <h3>" + v.username + "<div class='icon followUser dark " + isFollowing + "'><span></span></div></h3>\
                                      <p>" + v.bio + "</p>\
                                      <div class='forth'>Cards: " + v.cardCount + "</div>\
                                      <div class='forth'>Albums: " + v.albumCount + "</div>\
                                      <div class='forth'>Followers: " + v.followers + "</div>\
                                      <div class='forth'>Following: " + v.following + "</div>\
                                    </a>");
                });
                hideAlert();
              }
            })
            break;
        }
      }
        
        var keyTimer;
        
        $(document).on('click','.search, .searchGlass',function(){
          var modalData = " <div class='searchContainer'>\
                              <input type='text' class='searchTerms focus' placeholder='Search...' />\
                              <select class='searchType'>\
                                <option value='1'>All Cards</option>\
                                <option value='2'>This Album</option>\
                                <option value='3'>Users</option>\
                              </select>\
                            </div>\
                            <a href='#' class='button gold searchButton'>Search</a>";
          showModal("Search",modalData);
          if ($(this).hasClass('searchGlass')) {
            $('.searchType').val('2');
          }
          hideDrawer();
          return false;
        })
        .on('click','.searchButton',function(){
          var searchType = $('.searchType').val();
          var terms = $('.searchTerms').val();
          if (terms.length < 3) {
            showAlert("Please enter at least 3 characters.",2500);
          } else {
            searchResults(searchType,terms);
          }
          
          return false;
        })
        .on('keyup','.searchTerms',function(){
          var searchType = $('.searchType').val();
          var terms = $(this).val();
          if (keyTimer != undefined) {
            clearTimeout(keyTimer);
          }
          keyTimer = setTimeout(function(){
            if (terms.length > 2) {
              searchResults(searchType,terms);
            }
          }, 500)
        })
    
    $(document)
      .on('click','.loadFeed',function(){
        type = $(this).attr('type');
        sport = $(this).attr('sport');
        searchUserID = $(this).attr('searchUserID');
        albumID = $(this).attr('albumID');
        
        loadCards(myUserID,myUserKey,0,type,searchTerms,sport,searchUserID,albumID,true);
        
        return false;
      });
    
    var scrolledImg = undefined;
    var myScroll;
    var longpress = false;
    
    $(document)
      .on('click','.cardImg',function(){
        
        if ($(this).hasClass('ad')) {
          window.open($(this).attr('rel'), '_system');
        }
        
        /* if (scrolledImg != undefined) {
          myScroll.destroy();
          myScroll = null;
          $('#' + scrolledImg + " img").css('width','100%').removeAttr('style');
        }
        
        if ($(this).attr('id') != scrolledImg) {
          scrolledImg = $(this).attr('id');
        
          $('#'+scrolledImg+" img").css('width','auto');
          
          myScroll = new IScroll('#'+scrolledImg, {
            zoom: true,
            mouseWheel: true,
            wheelAction: 'zoom'
          });
        } else {
          scrolledImg = '';
        } */
        
        return false;
      })
      .on('click','.imgPreview',function(){
        var cardID = $(this).attr('rel');
        var smallIMG = $('.imgPreview[rel='+cardID+']').children('img').attr('src');
        var bigIMG = $('.cardImg img[rel='+cardID+']').attr('src');
        
        $('.cardImg img[rel='+cardID+']').attr('src',smallIMG);
        $('.imgPreview[rel='+cardID+']').children('img').attr('src',bigIMG);
        
        return false;
      });
    
    $(document)
      .on('click','.sharing',function(){
        var cardID = $(this).attr('rel');
        var cardTitle = $('.cardTitle[rel='+cardID+']').text();
        var cardIMG = $(this).parent().attr('rel');
        var cardURL = $(this).attr('href');
        
        if ($(this).hasClass('facebook')) {
          window.plugins.socialsharing.shareViaFacebook(cardTitle, cardIMG, cardURL, function() {}, function(errormsg){alert(errormsg)});
        }
        
        if ($(this).hasClass('twitter')) {
          window.plugins.socialsharing.shareViaTwitter("@sportscardalbum " + cardTitle, cardIMG, cardURL, function() {}, function(errormsg){alert(errormsg)});
        }
        
        if ($(this).hasClass('everything')) {
          var url = "[URL=" + cardURL + "][IMG]" + cardIMG + "[/IMG][/URL]";
          window.plugins.clipboard.copy(url,function(){showAlert("IMG Code Copied",2500);},function(response){showAlert("Error" + response,2500);});
        }
        
        return false;
      })
      .on('click','.ebay',function(){
        window.open($(this).attr('href'), '_system');
        return false;
      })
    
    function isScrolledIntoView(elem){
      var docViewTop = $(window).scrollTop();
      var docViewBottom = docViewTop + $(window).height();
    
      var elemTop = $(elem).offset().top;
      var elemBottom = elemTop + $(elem).height();
    
      return ((elemBottom <= docViewBottom) && (elemTop >= docViewTop));
    }
    
    loadCards(myUserID, myUserKey, 0, type, searchTerms, sport, searchUserID, albumID, true);
    
    $(document).on('click','.theImage',function(){
      var imgHeight = $(this).children('img').height();
      var cardID = $(this).attr('rel');
      
      if ($(this).hasClass('show')) {
        $(this).removeClass('show').css('height','150px');
      } else {
        $(this).addClass('show').css('height',imgHeight+'px');
      }
      
      if ($('.editor').length == 0) {
        $('.theImage').append("<div class='editor'><a href='#' class='icon rotate leftRotate' rel='"+ cardID +"'></a><a href='#' class='icon delete' rel='"+ cardID +"'></a><a href='#' class='icon rotate rightRotate' rel='"+ cardID +"'></a></div>");
      }
    });
    
    $(document)
      .on('click','.delete',function(){
        var cardID = $(this).attr('rel');
        
        showModal("Delete this card?","<a href='#' class='confirmDelete button gold' rel='" + cardID + "'>Yes, delete card.</a>");
        
        return false;
      })
      .on('click','.confirmDelete',function(){
        var cardID = $(this).attr('rel');
        
        $.ajax({
          dataType: "JSON",
          type: "POST",
          url: "http://sportscardalbum.com/api/deletecard",
          data: {userID:myUserID,key:myUserKey,cardID:cardID},
          success: function(data){
            if (data.response[0].code == 1) {
              showAlert('Card Deleted.',1500);
              hideModal();
              
              setTimeout(function(){
                loadCards(myUserID,myUserKey,0,type,searchTerms,sport,searchUserID,albumID,true);
              }, 1000);
              
            }
          }
        })
        
        return false;
      })
    
    
    var lastScrollPosition;
    var reload = false;
    var reloadTimer;
    
    $(document).scroll(
      function() {
        
        reload = true;
        
        if (isScrolledIntoView($('#hello')) && !$('#hello').hasClass('nope')) {
          if (loadMore) {
            loadCards(myUserID, myUserKey, ++count, type, searchTerms, sport, searchUserID, albumID, false);
          } else {
            showAlert("No more cards to load.", 2500);
          }
          
        }
        
        var scrollPosition = $(this).scrollTop();
        var header = $('.header');
        
        if (scrollPosition == 0 && reload && !$('#hello').hasClass('nope') && !isLoading) {
          $('.reloadLine').addClass('active');
          
          reloadTimer = setTimeout(function(){
            $('.reloadLine').removeClass('active');
            if (!isLoading) {
              count = 0;
              loadCards(myUserID, myUserKey, count, type, searchTerms, sport, searchUserID, albumID, true);
              showAlert("Refreshing Feed...", 2500);
            }
          }, 2500);
          
        }
        
        // Scrolling down
          if (scrollPosition > lastScrollPosition){
            
            clearTimeout(reloadTimer);
            $('.reloadLine').removeClass('active').attr('width','0%');
            
            // If the header is currently showing
            if (header.length && scrollPosition > 0) {
              header.hide();
              hideDrawer();
            }
            if (scrollPosition <= 50) {
              header.show();
            }
            
            /* 
            if (scrollPosition < -40) {
              pullReload = true;
              setTimeout(function(){
                if (pullReload) {
                  
                  pullReload = false;
                }
              }, 2000);
            } */
          } 
        
        // Scrolling up
          else {
            // If the header is currently hidden
            if (header.length && scrollPosition > 50) {
              header.show();
            }
          }
        
          lastScrollPosition = scrollPosition; 
      });
    
    // Messaging
      $(document)
        .on('click','.messages',function(){
          $.ajax({
            dataType: "JSON",
            url: "http://sportscardalbum.com/api/messages2",
            data: {userID:myUserID,key:myUserKey,start:0},
            success: function(data){
              
              console.log(data);
              
              if (data.response[0].code == 1) {
                $('#feed').html('');
                reload = false;
                $('#hello').addClass('nope');
                
                var messageLength = data.messages.length;
                
                if (messageLength == 1) {
                  showAlert("Loading " + messageLength + " message...");
                } else {
                  showAlert("Loading " + messageLength + " messages...");
                }
                hideDrawer();
                var i = 0;
                
                $.each(data.messages, function(k,v){
                  $('#feed').append(" <a href='#' class='messageBlock' rel='" + v.otherID + "'>\
                                  <img src='" + v.img + "' class='userImg' />\
                                  <h3><span class='msgUser" + v.otherID + "'>" + v.otherName + "</span><div class='right small'>" + v.date + "</div></h3>\
                                  <p>" + v.messagePreview + "</p>\
                                </a>");
                  i++;
                  if (i == messageLength) {
                    hideAlert();
                  }
                });
              } else {
                showAlert(data.response[0].responseText,2500);
                if (data.response[0].code === 3) {
                  
                  localStorage.clear();
                  window.location = "index.html";
                }
              }
            }
          });
          return false;
        })
        .on('click','.messageBlock',function(){
          var otherID = $(this).attr('rel');
          var msgUser = $('.msgUser'+otherID).text();
          $('.username').text(msgUser);
          $('.searchGlass').hide();
          $('.regNav').hide();
          $('.userNav').css('display','block');
          showAlert("Loading message...");
          $.ajax({
            dataType: "JSON",
            url: "http://sportscardalbum.com/api/message2",
            data: {userID:myUserID,otherID:otherID,key:myUserKey},
            success: function(data){
              if (data.response[0].code == 1) {
                $('#feed').html('');
                reload = false;
                $('#hello').addClass('nope');
                
                var messageLength = data.messages.length;
                
                if (messageLength == 1) {
                  showAlert("Loading " + messageLength + " message...");
                } else {
                  showAlert("Loading " + messageLength + " messages...");
                }
                hideDrawer();
                var i = 0;
                
                $.each(data.messages, function(k,v){
                  var position = "";
                  if (v.userID == myUserID) {
                    position = "mine";
                  }
                  $('#feed').append(" <div class='messageBlock smallBlock " + position + "'>\
                                        <img src='" + v.img + "' class='userImg' />\
                                        <div class='blurb'>\
                                          <h3>" + v.username + "<div class='right small'>" + v.date + "</div></h3>\
                                          <p>" + v.message + "</p>\
                                        </div>\
                                      </div>");
                  i++;
                  if (i == messageLength) {
                    hideAlert();
                    showModal("","<div class='messageResponse'><textarea class='respond' placeholder='Message...'></textarea><a href='#' rel='" + otherID + "' class='button gold sendMessage'>Send Message</a></div>");
                    $('.hideModal').remove();
                    $('#feed').append("<div class='messageSpacer'></div>");
                    $('.messageSpacer').css('height',$('.modal').height() + 20);
                    scrollTo(0,$(document).height());
                  }
                });
              }
            }
          });
          return false;
        })
        .on('click','.message',function(){
          var otherID = $(this).attr('rel');
          showAlert("Loading message...");
          // console.log('http://sportscardalbum.com/api/message2/userID='+myUserID+'&otherID='+otherID+'&key='+myUserKey);
          var messageList = "";
          $.ajax({
            dataType: "JSON",
            url: "http://sportscardalbum.com/api/message2",
            data: {userID:myUserID,otherID:otherID,key:myUserKey},
            success: function(data){
              
              var code = data.response[0].code;
              
              if (code == 1) {
                var messageLength = data.messages.length;
                
                if (messageLength == 1) {
                  showAlert("Loading " + messageLength + " message...");
                } else {
                  showAlert("Loading " + messageLength + " messages...");
                }
                hideDrawer();
                var i = 0;
                
                $.each(data.messages, function(k,v){
                  var position = "";
                  if (v.userID == myUserID) {
                    position = "mine";
                  }
                  messageList += " <div class='messageBlock smallBlock " + position + "'>\
                                        <img src='" + v.img + "' class='userImg' />\
                                        <div class='blurb'>\
                                          <h3>" + v.username + "<div class='right small'>" + v.date + "</div></h3>\
                                          <p>" + v.message + "</p>\
                                        </div>\
                                      </div>";
                  i++;
                  if (i == messageLength) {
                    hideAlert();
                    showModal("","<div class='modalHolder' id='scrollBottom'>"+messageList+"</div><div class='messageResponse'><textarea class='respond' placeholder='Message...'></textarea><a href='#' rel='" + otherID + "' class='button gold sendMessage'>Send Message</a></div>");
                    var objDiv = document.getElementById('scrollBottom');
                    objDiv.scrollTop = objDiv.scrollHeight;
                  }
                });
              }
              
              if (code == 4) {
                hideDrawer();
                hideAlert();
                showModal("","<div class='modalHolder' id='scrollBottom'></div><div class='messageResponse'><textarea class='respond' placeholder='Message...'></textarea><a href='#' rel='" + otherID + "' class='button gold sendMessage'>Send Message</a></div>");
              }
              
              if (code == 2 || code == 3){
                hideAlert();
                showAlert(data.response[0].responseText);
              }
            }
          });
          return false;
        })
        .on('click','.sendMessage',function(){
          var toID = $(this).attr('rel');
          var message = $('.respond').val();
          if (message == '') {
            showAlert("Please provide a message.",2500);
          } else {
            showAlert("Sending message...");
            $.ajax({
              dataType: "JSON",
              url: "http://sportscardalbum.com/api/addmessage",
              data: {fromID:myUserID,key:myUserKey,toID:toID,message:message},
              success: function(data){
                var newMessage = " <div class='messageBlock smallBlock mine'>\
                                              <img src='" + myImg + "' class='userImg' />\
                                              <div class='blurb'>\
                                                <h3>" + myUsername + "<div class='right small'>Now</div></h3>\
                                                <p>" + message + "</p>\
                                              </div>\
                                            </div>";
                
                if ($('.modalHolder').length > 0) {
                  $('.modalHolder').append(newMessage);
                  var objDiv = document.getElementById('scrollBottom');
                  objDiv.scrollTop = objDiv.scrollHeight;
                } else {
                  $('.messageSpacer').before();
                  scrollTo(0,$(document).height());
                }
                
                $('.respond').val('');
                hideAlert();
              }
            })
          }
          
          return false;
        })
        .on('click','.comments',function(){
          var cardID = $(this).attr('rel');
          showAlert("Loading comments...");
          var messageList = "";
          console.log("http://sportscardalbum.com/api/comments?userID="+myUserID+"&cardID="+cardID+"&start=0");
          $.ajax({
            dataType: "JSON",
            url: "http://sportscardalbum.com/api/comments",
            data: {userID:myUserID,cardID:cardID,start:0},
            success: function(data){
              console.log(data);
              var code = data.response[0].code;
              if (code != 3) {
                
                if (code == 1) {
                
                  var messageLength = data.comments.length;
                  
                  if (messageLength == 1) {
                    showAlert("Loading " + messageLength + " comment...");
                  } else {
                    showAlert("Loading " + messageLength + " comments...");
                  }
                  hideDrawer();
                  var i = 0;
                  
                  $.each(data.comments, function(k,v){
                    var position = "";
                    if (v.userID == myUserID) {
                      position = "mine";
                    }
                    messageList += " <div class='messageBlock smallBlock " + position + "'>\
                                          <img src='" + v.img + "' class='userImg' />\
                                          <div class='blurb'>\
                                            <h3>" + v.username + "<div class='right small'>" + v.date + "</div></h3>\
                                            <p>" + v.comment + "</p>\
                                          </div>\
                                        </div>";
                    i++;
                    if (i == messageLength) {
                      hideAlert();
                      showModal("","<div class='modalHolder' id='scrollBottom'>"+messageList+"</div><div class='messageResponse'><textarea class='respond' placeholder='Add Comment...'></textarea><a href='#' rel='" + cardID + "' class='button gold sendComment'>Send Comment</a></div>");
                      var objDiv = document.getElementById('scrollBottom');
                      objDiv.scrollTop = objDiv.scrollHeight;
                    }
                  });
                
                } else {
                  
                  hideAlert();
                  showModal("","<div class='modalHolder' id='scrollBottom'></div><div class='messageResponse'><textarea class='respond' placeholder='Add Comment...'></textarea><a href='#' rel='" + cardID + "' class='button gold sendComment'>Send Comment</a></div>");
                  
                }
              } else {
                showAlert(data.response[0].responseText,2500);
              }
            }
          });
          return false;
        })
        .on('click','.sendComment',function(){
          var cardID = $(this).attr('rel');
          var message = $('.respond').val();
          if (message == '') {
            showAlert("Please provide a comment.",2500);
          } else {
            showAlert("Sending comment...");
            $.ajax({
              dataType: "JSON",
              url: "http://sportscardalbum.com/api/comments",
              data: {comment:message,userID:myUserID,key:myUserKey,cardID:cardID},
              success: function(data){
                var newMessage = " <div class='messageBlock smallBlock mine'>\
                                              <img src='" + myImg + "' class='userImg' />\
                                              <div class='blurb'>\
                                                <h3>" + myUsername + "<div class='right small'>Now</div></h3>\
                                                <p>" + message + "</p>\
                                              </div>\
                                            </div>";
                
                if ($('.modalHolder').length > 0) {
                  $('.modalHolder').append(newMessage);
                  var objDiv = document.getElementById('scrollBottom');
                  objDiv.scrollTop = objDiv.scrollHeight;
                } else {
                  $('.messageSpacer').before();
                  scrollTo(0,$(document).height());
                }
                
                $('.respond').val('');
                hideAlert();
                var commentCount = $('.comments[rel='+cardID+']').text();
                commentCount = parseInt(commentCount);
                $('.comments[rel='+cardID+']').text(commentCount + 1);
              }
            })
          }
          
          return false;
        });
    
    
    $(document).on('click','.edit',function(){
      var cardID = $(this).attr('rel');
      $.ajax({
        dataType: "JSON",
        type: "POST",
        url: "http://sportscardalbum.com/api/carddetails",
        data: {cardID:cardID},
        success: function(data){
          
          $('.regNav, .searchGlass').css('display','none');
          $('.username').html("Edit Card");
          $('.userNav').css('display','block');
          
          i = 0;
          
          $('.theImage').attr('rel',cardID).html("<img src='" + data.cards[0].imgURL + "' />").removeClass('add');
          $('.saveCard').removeClass('disabled').attr('rel',cardID).text("Save Card Details");
          
          var tags = data.cards[0].tags;
          $('.tagList').val(tags);
          tags = tags.split('');
          for (i=0; i<tags.length;i++) {
            $('.tags a[rel='+tags[i]+']').addClass('selected');
          }
          
          $('.sportSelect').val(data.cards[0].sport);
          
          i=0;
          
          $.each(data.cards[0], function(k, v){
            if (k != 'tags' && k != 'imgURL' && k != 'sport') {
              $('.'+k).val(v);
            }
            
            console.log(k + " : " + v);
            i++;
            
            if (i == 15) {
          
              $.ajax({
                dataType: "JSON",
                url: "http://sportscardalbum.com/api/useralbums",
                data: {userid:myUserID},
                success: function(data){
                  var totalAlbums = data.albums.length;
                  var i = 0;
                  
                  if (totalAlbums == 0) {
                    var modalData = $('.hidden.holder').html();
                    showModal("Add an Album",modalData);
                  } else {
                    $.each(data.albums, function(k, v){
                      showAlbums(myUserID, v.album, 0, '.albumSelect',3);
                      i++;
                    });
                  }
                }
              });
              
              loadMore = false;
              isLoading = true;
              $('.profile, .regNav, .searchGlass').css('display','none');
              $('.username').html("Edit Card");
              $('.userNav').css('display','block');
              $('.back').attr('rel',myUserID);
              $('#hello').addClass('nope');
              $('#feed').html('');
              $('body').removeAttr('id');
              window.scrollTo(0,0);
              $('.imageDetails').css('display','block');
            }
          });
        }
      })
      return false;
    })
    
    
    // Uploading a picture
    
      $(document)
        .on('click','.add',function(){
          showModal('',"<a href='#' class='button gold fromCamera hidden'>Upload from Camera</a>\
                        <a href='#' class='button gold fromGallery'>Upload from Files</a>");
          return false;
        })
        .on('click','.fromCamera',function(){
          getPhoto(pictureSource.CAMERA);
          return false;
        })
        .on('click','.fromGallery',function(){
          getPhoto(pictureSource.PHOTOLIBRARY);
          return false;
        })
        .on('click','.addImage',function(){
          loadMore = false;
          isLoading = true;
          $('#hello').addClass('nope');
          $('#feed').html('');
          $('.imageDetails').css('display','block');
          
          $('.form input').val('');
          $('.form select').val(0);
          $('.tags a').removeClass('selected');
          $('.albums').html("<option value='0'>Select an Album</option>");
          
          if (!$('.theImage').hasClass('add')) {
            $('.theImage').html('Select an Image').addClass('add');
            $('.saveCard').addClass('disabled').html('Waiting for card image...').attr('rel','0');
          }
          
          $.ajax({
            dataType: "JSON",
            url: "http://sportscardalbum.com/api/useralbums",
            data: {userid:myUserID},
            success: function(data){
              var totalAlbums = data.albums.length;
              var i = 0;
              
              $.each(data.albums, function(k, v){
                showAlbums(myUserID, v.album, 0, '.albums',3);
                i++;
              });
            }
          });
          
          return false;
        });
    
      
        /* var data = '{"response": [{"code":"1","responseText":"File Uploaded","cardID":"240829","imageURLMedium":"http://sportscardalbum.com/c/0ej8mj96x450.jpg"}]}';
        data = JSON.parse(data);
        console.log(data);
        $(document).ready(function(){
          if (data.response[0].code == 1) {
            var cardID = data.response[0].cardID;
            var cardURL = data.response[0].imageURLMedium;
            
            console.log(cardID + "," + cardURL);
              
            $('.theImage').html("<img src='" + cardURL + "' />").removeClass('add');
            $('.saveCard').removeClass('disabled').attr('rel',cardID).text("Save Card Details");
          }
        }) */
      
    
      var pictureSource;   // picture source
      var destinationType; // sets the format of returned value
    
      // Wait for device API libraries to load
      //
      document.addEventListener("deviceready",onDeviceReady,false);
    
      // device APIs are available
      //
      function onDeviceReady() {
          pictureSource=navigator.camera.PictureSourceType;
          destinationType=navigator.camera.DestinationType;
      }
    
      // Called when a photo is successfully retrieved
      //
      
      function onPhotoURISuccess(imageURI) {
        var options = new FileUploadOptions();
        options.fileKey="front";
        options.fileName=imageURI.substr(imageURI.lastIndexOf('/')+1)+'.jpg';
        options.mimeType="text/plain";
    
        var params = new Object();
        params.userID = window.localStorage.getItem("myUserID");
        params.key = window.localStorage.getItem("myUserKey");
    
        options.params = params;
        options.chunkedMode = true;
        
        var ft = new FileTransfer();
        ft.upload(imageURI, encodeURI("http://sportscardalbum.com/api/uploadcard"), win, fail, options);
        
        $('.theImage').html('Uploading Image...').removeClass('add');
        hideModal();
      }
        
      function win(r) {
        
        data = JSON.parse(r.response);
        
        if (data.response[0].code == 1) {
          var cardID = cardID = data.response[0].cardID;
          var cardURL = cardURL = data.response[0].imageURLMedium;
          
          $('.theImage').attr('rel',cardID).html("<img src='" + cardURL + "' />");
          $('.saveCard').removeClass('disabled').attr('rel',cardID).text("Save Card Details");
        }
      }
      
      function fail(error) {
        alert("An error has occurred: Code = " + error.code);
        console.log("upload error source " + error.source);
        console.log("upload error target " + error.target);
      }
    
      // A button will call this function
      //
      function getPhoto(source) {
        // Retrieve image file location from specified source
        navigator.camera.getPicture(onPhotoURISuccess, onFail, { quality: 50,
          destinationType: destinationType.FILE_URI,
          sourceType: source });
      }
    
      // Called if something bad happens.
      //
      function onFail(message) {
        alert('Failed because: ' + message);
      }
      
      $(document)
        .on('click','.tags a',function(){
          var tagList = $('.tagList').val();
          var tagID = $(this).attr('rel');
          if ($(this).hasClass('selected')) {
            tagList = tagList.replace(tagID,'');
          } else {
            tagList = tagList + tagID;
          }
          $(this).toggleClass('selected');
          $('.tagList').val(tagList);
          return false;
        })
        .on('click','.saveCard',function(){
          var cardID = $(this).attr('rel');
          if (cardID == 0) {
            showAlert("Error : No Card ID Supplied",2500);
          } else {
            var yr = $('.yr').val();
            var mfg = $('.mfg').val();
            var brand = $('.brand').val();
            var desc = $('.desc').val();
            var sport = $('.sportSelect').val();
            var album = $('.albumSelect').val();
            var sv = $('.sv').val();
            var tv = $('.tv').val();
            var sn = $('.sn').val();
            var cn = $('.cn').val();
            var grader = $('.grader').val();
            var gr = $('.gr').val();
            var tags = $('.tagList').val();
            var ebayID = $('.ebayID').val();
            
            // console.log("http://sportscardalbum.com/api/updatecard?cardID="+cardID+"&yr="+yr+"&mfg="+mfg+"&brand="+brand+"&desc="+desc+"&sport="+sport+"&album="+album+"&sv="+sv+"&tv="+tv+"&sn="+sn+"&grader="+grader+"&gr="+gr+"&tags="+tags+"&ebayID="+ebayID);
            
            $.ajax({
              dataType: "JSON",
              type: "POST",
              url: "http://sportscardalbum.com/api/updatecard",
              data: {userID:myUserID,key:myUserKey,cardID:cardID,yr:yr,mfg:mfg,brand:brand,desc:desc,sport:sport,album:album,sv:sv,tv:tv,sn:sn,cn:cn,grader:grader,gr:gr,tags:tags,ebayID:ebayID},
              success: function(data){
                if (data.response[0].code != 1) {
                  showAlert("Update Error : " + data.response[0].responseText + "<br />Please try updating again.",2500);
                } else {
                  showAlert(data.response[0].responseText,2500);
                  loadMore = true;
                  isLoading = false;
                  $('#hello').removeClass('nope');
                  type = 2;
                  sport = undefined;
                  searchTerms = undefined;
                  searchUserID = myUserID;
                  albumID = 1;
                  loadCards(myUserID,myUserKey,0,type,searchTerms,sport,searchUserID,albumID,true);
                  $('.imageDetails').hide();
                }
              }
            })
          }
        
        return false;
      });
        
        
    $(document).on('click','.rotate',function(){
      var side = 1;
      var rotate = 90;
      var cardID = $(this).attr('rel');
      
      if ($(this).hasClass('leftRotate')) {
        rotate = -90;
      }
      
      $.ajax({
        dataType: "JSON",
        type: "POST",
        url: "http://sportscardalbum.com/api/rotatecard",
        data: {userID:myUserID,key:myUserKey,cardID:cardID,side:side,d:rotate},
        success: function(data){
          if (data.response[0].code == 1 ) {
            var img = $('.theImage img').attr('src');
            $('.theImage img').replaceWith("<img src='" + img + "?1' />");
            $('.theImage').removeClass('show').css('height','150px');
          } else {
            showAlert(data.response[0].responseText,2500);
          }
        }
      })
      
      return false;
    })
  }

})
